#!/bin/bash -eE
# (c) 2019 Mellanox Technologies
# Author: Yurii Shestakov
#------------------------------------------------------------------------
MLX_DEV=$1
logger -p local0.notice -t nvme_snap "$0: $1"
# compatability with old configuration
# when we have no systemd unit template: nvmx@.service
if [ -z "$MLX_DEV" ] ; then
  if [ -e /etc/default/nvmx ] ; then
    source /etc/default/nvmx
  fi
  if [ -z "$MLX_DEV" ] ; then
    echo "ERR: Can't find NVME controller device" >&2
    exit 1
  fi
else
  env_fn="/etc/default/nvmx.$MLX_DEV"
  logger -p local0.notice -t nvme_snap "$MLX_DEV: env_fn: $env_fn"
  if [ -e "$env_fn" ] ; then
    source "$env_fn"
  fi
  if [ -z "$NVME_CONFIG" ] ; then
    export NVME_CONFIG="/etc/nvme_snap/$MLX_DEV.json"
  fi
fi
logger -p local0.notice -t nvme_snap "$MLX_DEV: NVME_CONFIG: $NVME_CONFIG"
if [ -n "$NVME_SNAP_LOGFILE_PATH" ] ; then
  logger -p local0.notice -t nvme_snap "$MLX_DEV: NVME_SNAP_LOGFILE_PATH: $NVME_SNAP_LOGFILE_PATH"
fi

if ! /usr/sbin/mlx_device_emulation $MLX_DEV ; then
    echo "$MLX_DEV is not emulation manager. Nothing to do..." >&2
    exit 1
fi

exec /usr/bin/nvme_controller_emu $MLX_DEV
